/*********************************************************************
 *                
 * Filename:      obex.h
 * Version:       1.0
 * Description:   OBEX API
 * Status:        Experimental.
 * Author:        Dag Brattli <dagb@cs.uit.no>
 * Created at:    Fri Apr 23 14:02:42 1999
 * Modified at:   Sun May 23 09:24:01 1999
 * Modified by:   Dag Brattli <dagb@cs.uit.no>
 * 
 *     Copyright (c) 1999 Dag Brattli, All Rights Reserved.
 *     
 *     This library is free software; you can redistribute it and/or
 *     modify it under the terms of the GNU Lesser General Public
 *     License as published by the Free Software Foundation; either
 *     version 2 of the License, or (at your option) any later version.
 *
 *     This library is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *     Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public
 *     License along with this library; if not, write to the Free Software
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *     MA  02111-1307  USA
 *     
 ********************************************************************/

#ifndef OBEX_H
#define OBEX_H

#include "obex_main.h"
#include "obex_object.h"
#include "obex_header.h"

/*
 *  OBEX API
 */
obex_t *OBEX_Init(int domain, obex_notify_t *notify, int async);
void    OBEX_Cleanup(obex_t *self);
gint    OBEX_ConnectRequest(obex_t *self, struct sockaddr *saddr, int addlen);
gint    OBEX_ConnectResponse(obex_t *self);
gint    OBEX_DisconnectRequest(obex_t *self);
gint    OBEX_PutRequest(obex_t *self, obex_object_t *object);
gint    OBEX_GetRequest(obex_t *self, char *name);
gint    OBEX_ServerRegister(obex_t *self, char *service);
void    OBEX_NotifyInit(obex_notify_t *notify);
gint    OBEX_HandleInput(obex_t *self, gint timeout);
gint    OBEX_CancelRequest(obex_t *self);
gint    OBEX_ExtractHeader(GNetBuf *msg, obex_header_t *header);

obex_object_t *OBEX_ObjectNew(char *name, char *description);
gint           OBEX_ObjectDelete(obex_object_t *object);
gint           OBEX_ObjectAddBody(obex_object_t *object, GNetBuf *msg);
gint           OBEX_ObjectSetLength(obex_object_t *object, gint length);

#define OBEX_GetLastResponseMessage obex_get_last_response_message

/*
 * IrOBEX API 
 */
gint IrOBEX_ConnectRequest(obex_t *self, char *service);


#endif
