/*********************************************************************
 *                
 * Filename:      obex_event.h
 * Version:       
 * Description:   
 * Status:        Experimental.
 * Author:        Dag Brattli <dagb@cs.uit.no>
 * Created at:    Tue Jan 19 13:51:27 1999
 * Modified at:   Sat May 22 15:13:34 1999
 * Modified by:   Dag Brattli <dagb@cs.uit.no>
 * 
 *     Copyright (c) 1998-1999 Dag Brattli, All Rights Reserved.
 *      
 *     This library is free software; you can redistribute it and/or
 *     modify it under the terms of the GNU Lesser General Public
 *     License as published by the Free Software Foundation; either
 *     version 2 of the License, or (at your option) any later version.
 *
 *     This library is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *     Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public
 *     License along with this library; if not, write to the Free Software
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *     MA  02111-1307  USA
 *     
 ********************************************************************/

#ifndef OBEX_EVENT_H
#define OBEX_EVENT_H

/* IrOBEX states */
typedef enum {
	STATE_DISCONNECTED,
	STATE_SETUP,
	STATE_READY,
	STATE_PUT,
	STATE_GET,
} OBEX_STATE;

/* State of the PUT command */
typedef enum {
	STATE_PUT_IDLE,
	STATE_PUT_HEADERS,
	STATE_PUT_BODY,
} PUT_STATE;


/* OBEX events */
typedef enum {
	EVENT_CONNECT_INDICATION,
	EVENT_CONNECT_REQUEST,
	EVENT_DISCONNECT_INDICATION,
	EVENT_DISCONNECT_REQUEST,
	EVENT_GET_REQUEST,
	EVENT_GET_INDICATION,
	EVENT_PUT_REQUEST,
	EVENT_PUT_INDICATION,
	EVENT_RESPONSE_INDICATION,
	EVENT_SETPATH_INDICATION,
} OBEX_EVENT;

inline void obex_next_state(obex_t *self, OBEX_STATE state);
inline gint obex_do_event(obex_t *self, OBEX_EVENT event, GNetBuf *msg, 
			  gint final);

#endif
